/****************************************************************************** 
 *                      Sources BCB - www.developpez.com                      * 
 * -------------------------------------------------------------------------- * 
 *                                                                            * 
 * HCDControl.cpp                                                             *
 * Version: 1.0.0 mise  jour le 9 janvier 2005                               *
 * Copyright Cryptonyx (http://five.chez.tiscali.fr)                          * 
 *                                                                            * 
 * Test avec:                                                                * 
 * SE: Win98, WinXP                                                           *
 * IDE: BCB5                                                                  * 
 *                                                                            * 
 * -------------------------------------------------------------------------- * 
 *                                                                            *
 * Ce code illustre une compression/dcompression de type Huffman             *
 *                                                                            *
 * -------------------------------------------------------------------------- * 
 *                                                                            * 
 * Retrouvez d'autres ressources BCB sur :                                    * 
 *  - http://c.developpez.com/sources/bcb/                                    * 
 *  - http://c.developpez.com/faq/bcb/                                        * 
 * Ainsi que sur les forums (http://www.developpez.net/forums/)               * 
 *                                                                            * 
 ******************************************************************************/

#include <vcl.h>
#include "HCDFunctions.h"
#include "HCDMessagesForControl.h"
#include "HCDControl.h"
#pragma hdrstop
#pragma package(smart_init)
#pragma resource "*.dfm"
//---------------------------------------------------------------------------
THCDForm *HCDForm;
//---------------------------------------------------------------------------
__fastcall THCDForm::THCDForm(TComponent* Owner)
    : TForm(Owner)
{
}

//---------------------------------------------------------------------------
void __fastcall THCDForm::FormCreate(TObject *Sender)
{
	CompressButton->Caption = GUIMessages[0];
	DecompressButton->Caption = GUIMessages[1];
}

//---------------------------------------------------------------------------
void __fastcall THCDForm::CompressButtonClick(TObject *Sender)
{
    // compresse un fichier selectionn
    HCDOpenDialog->Title = ListOfMessages[0];
    HCDOpenDialog->DefaultExt = "";
    HCDOpenDialog->FileName = "*.*";
    if(HCDOpenDialog->Execute() == false)
        return;

    THuffman *HCDInstance = new THuffman();

    DisplayLine->Text = HCDOpenDialog->FileName;
    HCDRichEdit->Lines->Clear();
    HCDRichEdit->Lines->Add(ListOfMessages[1] + TimeToStr(Time()));
    Repaint();

    HCDInstance->FileCompress(DisplayLine->Text, DisplayLine->Text + ListOfMessages[2]);

    HCDRichEdit->Lines->Add(ListOfMessages[3] + TimeToStr(Time()));
    HCDRichEdit->Lines->Add(HCDInstance->GetLastError());
    delete HCDInstance;
}
//---------------------------------------------------------------------------
void __fastcall THCDForm::DecompressButtonClick(TObject *Sender)
{
int i;

    // decompresse un fichier selectionn
    HCDOpenDialog->Title = ListOfMessages[4];
    HCDOpenDialog->DefaultExt = ListOfMessages[2];
    HCDOpenDialog->FileName = ListOfMessages[5];
    if(HCDOpenDialog->Execute() == false)
        return;

    DisplayLine->Text = HCDOpenDialog->FileName;
    // le fichier doit avoir une extension correcte
    i = DisplayLine->Text.LastDelimiter(".");
    if(DisplayLine->Text.SubString(i, DisplayLine->Text.Length() - i + 1) != ListOfMessages[2]) {
        MessageDlg(ListOfMessages[6], mtError, TMsgDlgButtons() << mbOK, 0);
        return;
    }
    if(i < 5) {
        MessageDlg(ListOfMessages[7], mtError, TMsgDlgButtons() << mbOK, 0);
        return;
    }
    HCDRichEdit->Lines->Clear();
    HCDRichEdit->Lines->Add(ListOfMessages[8] + TimeToStr(Time()));
    THuffman *HCDInstance = new THuffman();
    Repaint();

    HCDInstance->FileDecompress(DisplayLine->Text, DisplayLine->Text.SubString(1, i - 1));

    HCDRichEdit->Lines->Add(ListOfMessages[9] + TimeToStr(Time()));
    HCDRichEdit->Lines->Add(HCDInstance->GetLastError());
    delete HCDInstance;
}
//---------------------------------------------------------------------------

